#!/usr/bin/python
fout = open("PAL.BIN", "wb")
fout.write(bytearray([ 0x00, 0xfa ]))

def  make_pal(fg, bg):
    for i in range(4):
        for j in range(16):
            # foreground colour if (1<<i)&j
            if (1<<i)&j:
                c = fg
            else:
                c = bg
            fout.write(bytearray([ c&0xff, c>>8 ]))

pal = []
make_pal(0x0000, 0x0fff)    # black on white
make_pal(0x0f00, 0x0fff)    # red on white
make_pal(0x0fff, 0x0000)    # white on black (ish)
make_pal(0x0f00, 0x0000)    # red on black (ish)

fout.close()
