serial_chrin:
    stx $ff     ; save .X
    lda #1
    ldx #8
    ldy #0
        jsr setlfs
    lda #5
    ldx #<_fname
    ldy #>_fname
        jsr setnam
    lda #0
    ldx #<_buffer
    ldy #>_buffer
        jsr load
    lda _buffer
    beq _return

    ; now overwrite the file to signal input is accepted
    stz _buffer_zero    ; just in case something went wrong
    ; first byte
    lda #<_buffer_zero
    sta r0_lo
    lda #>_buffer_zero
    sta r0_hi
    ; last byte
    ldx #<(_buffer_zero+1)
    ldy #>(_buffer_zero+1)
    lda #r0
    jsr save
    
    lda _buffer
_return:
    ldx $ff     ; restore .X
    rts
_fname:
    .enc "none"
    .text "STDIN"
_buffer:
    .text 0
_buffer_zero:
    .text 0

serial_chrout:
    stx $ff
    sta _ch
_loop:
    lda #1
    ldx #8
    ldy #0
        jsr setlfs
    lda #6
    ldx #<_fname
    ldy #>_fname
        jsr setnam
    lda #0
    ldx #<_buffer
    ldy #>_buffer
        jsr load
    lda _buffer
    bne _loop ; loop until pipe is ready

    ; first byte
    lda #<_ch
    sta r0_lo
    lda #>_ch
    sta r0_hi
    ; last byte
    ldx #<(_ch+1)
    ldy #>(_ch+1)
    lda #r0
    jsr save

    ldx $ff
    rts
_fname:
    .enc "none"
    .text "STDOUT"
_ch
    .text 0
_buffer:
    .text 0
